<template>
  <section id="vlue-dev-sidebar">
    <section id="vlue-dev-sidebar-top">
      <div id="vlue-dev-sidebar-logo"></div>
    </section>
    <section id="vlue-dev-sidebar-main">
      <div class="vlue-dev-sidebar-button-row">
        <input class="vlue-dev-sidebar-button"
          :disabled="!websiteHistoryUndo.length"
          type="button" value="Undo" v-on:click="undo()">
        <input class="vlue-dev-sidebar-button"
          :disabled="!websiteHistoryRedo.length"
          type="button" value="Redo" v-on:click="redo()">
      </div>
      <hr>
      <div class="vlue-dev-sidebar-button-row">
        <input class="vlue-dev-sidebar-button" id="vlue-dev-sidebar-button-create"
          type="button" value="Create" v-on:click="setMode('create')">
        <input class="vlue-dev-sidebar-button" id="vlue-dev-sidebar-button-edit"
          type="button" value="Edit" v-on:click="setMode('edit')">
      </div>
      <div class="vlue-dev-sidebar-button-row">
        <input class="vlue-dev-sidebar-button" id="vlue-dev-sidebar-button-move"
          type="button" value="Move" v-on:click="setMode('move')">
        <input class="vlue-dev-sidebar-button" id="vlue-dev-sidebar-button-delete"
          type="button" value="Delete" v-on:click="setMode('delete')">
      </div>
      <hr>
      <div class="vlue-dev-sidebar-button-row">
        <input class="vlue-dev-sidebar-button"
          :class="{ selected: editFrame }"
          type="button"
          :disabled="selectedLayer != 'base'"
          v-on:click="toggleEditFrame()"
          value="Frame">
        <input class="vlue-dev-sidebar-button"
          :class="{ selected: editPage }"
          type="button"
          :disabled="selectedLayer != 'base'"
          v-on:click="toggleEditPage()"
          value="Page">
      </div>
      <sidebar-section :expandedByDefault="websiteGenerationSpinner">
        <h3 slot="top">File</h3>
        <input class="vlue-dev-sidebar-button"
          type="button" value="Download To ZIP"
          v-on:click="downloadGeneratedWebsite()">
        <div class="vlue-dev-sidebar-button-spinner" v-if="websiteGenerationSpinner"></div>
        <input id="upload-zip-file-input"
          type="file"
          v-on:change="uploadGeneratedWebsite"
          accept=".zip">
        <input class="vlue-dev-sidebar-button"
          type="button" value="Upload From ZIP"
          v-on:click="uploadGeneratedWebsiteClick()">
        <input class="vlue-dev-sidebar-button"
          v-if="isDevelopment()"
          type="button" value="Save Changes"
          v-on:click="saveChanges()">
        <input class="vlue-dev-sidebar-button"
          v-if="isDevelopment()"
          type="button" value="Revert Changes"
          v-on:click="revertChanges()">
        <input class="vlue-dev-sidebar-button"
          type="button" value="Clean Slate"
          v-on:click="cleanSlate()">
      </sidebar-section>
      <sidebar-section>
        <h3 slot="top">Layers</h3>
        <div class="vlue-dev-sidebar-button-row vlue-dev-sidebar-button-row-layers"
          v-for="layer in ['fixed', 'base']">
          <input class="vlue-dev-sidebar-button"
            :class="{ selected : selectedLayer == layer }"
            v-on:click="setSelectedLayer(layer)"
            type="button"
            :value="layer">
          <input class="vlue-dev-sidebar-button"
            type="button"
            v-on:click="setLayerVisibility(layer)"
            :value="layerVisibility[layer] ? 'ö.ö' : 'u.u'">
        </div>
      </sidebar-section>
      <sidebar-section>
        <h3 slot="top">Responsive Layout</h3>
        <sidebar-property-field
          :prop="{
            name: 'viewportWidth',
            type: 'textfield',
            value: viewportWidth,
          }">
        </sidebar-property-field>
        <input class="vlue-dev-sidebar-button"
          v-if="viewportWidth"
          type="button"
          value="fit to browser"
          v-on:click="resetViewportWidth()">
      </sidebar-section>
      <sidebar-section class="vlue-dev-sidebar-mobile-menu"
        v-if="website.mobileMenu">
        <h3 slot="top">Mobile Menu</h3>
        <div class="vlue-dev-sidebar-button-row">
          <input class="vlue-dev-sidebar-button"
            :class="{ selected : website.mobileMenu.align == 'top-left' }"
            type="button" value="<" v-on:click="setMobileMenuAlignment('top-left')">
          <input class="vlue-dev-sidebar-button"
            :class="{ selected : website.mobileMenu.align == 'top-right' }"
            type="button" value=">" v-on:click="setMobileMenuAlignment('top-right')">
        </div>
        <div class="vlue-dev-sidebar-button-row">
          <input class="vlue-dev-sidebar-button"
            :class="{ selected : website.mobileMenu.align == 'bottom-left' }"
            type="button" value="<" v-on:click="setMobileMenuAlignment('bottom-left')">
          <input class="vlue-dev-sidebar-button"
            :class="{ selected : website.mobileMenu.align == 'bottom-right' }"
            type="button" value=">" v-on:click="setMobileMenuAlignment('bottom-right')">
        </div>
        <div class="vlue-dev-sidebar-button-row">
          <input class="vlue-dev-sidebar-button"
            :class="{ selected : website.mobileMenu.type == 'expand' }"
            type="button" value="expand" v-on:click="setMobileMenuType('expand')">
          <input class="vlue-dev-sidebar-button"
            :class="{ selected : website.mobileMenu.type == 'slide' }"
            type="button" value="slide"  v-on:click="setMobileMenuType('slide')">
        </div>
        <sidebar-property-field
          :required="true"
          :current="website.mobileMenu"
          :prop="{
            name: 'colorA',
            type: 'color',
            value: website.mobileMenu.colorA,
          }">
        </sidebar-property-field>
        <sidebar-property-field
          :required="true"
          :current="website.mobileMenu"
          :prop="{
            name: 'colorB',
            type: 'color',
            value: website.mobileMenu.colorB,
          }">
        </sidebar-property-field>
        <input class="vlue-dev-sidebar-button" type="button"
          value="swap colors" v-on:click="swapMobileMenuColors()">
      </sidebar-section>
      <sidebar-section>
        <h3 slot="top">Pages</h3>
        <sidebar-property-field
          :prop="{
            name: 'currentPage',
            type: 'dropdown',
            options: pageNames,
            value: currentPage,
          }">
        </sidebar-property-field>
        <sidebar-property-field
          v-if="currentPageContainer"
          :current="currentPageContainer"
          :prop="{
            name: 'parentPageName',
            type: 'dropdown',
            options: ['', ...parentPageNames],
            value: currentPageContainer.parentPageName,
          }">
        </sidebar-property-field>
        <sidebar-property-field
          v-if="currentPageContainer"
          :required="true"
          :current="currentPageContainer"
          :prop="{
            name: 'pageName',
            type: 'textfield',
            value: currentPageContainer.pageName,
          }">
        </sidebar-property-field>
        <div class="vlue-dev-sidebar-button-row">
          <input class="vlue-dev-sidebar-button"
            type="button"
            value="new"
            v-on:click="addPage()">
          <input class="vlue-dev-sidebar-button"
            type="button"
            value="remove"
            :disabled="((website.pageContainers || []).length < 2)"
            v-on:click="removePage()">
        </div>
        <div class="vlue-dev-sidebar-button-row">
          <input class="vlue-dev-sidebar-button"
            type="button"
            value="< sort"
            :disabled="(currentPageContainerIndex == 0)"
            v-on:click="sortPage('up')">
          <input class="vlue-dev-sidebar-button"
            type="button"
            value="sort >"
            :disabled="(currentPageContainerIndex == (website.pageContainers || []).length - 1)"
            v-on:click="sortPage('down')">
        </div>
      </sidebar-section>
      <sidebar-section>
        <h3 slot="top">Global Component Props</h3>
        <div v-for="folder in Object.keys(contentComponentProps)">
          <sidebar-section v-for="name in Object.keys(contentComponentProps[folder])"
            :key="'global-component-props-' + folder + name"
            v-if="Object.keys(contentComponentProps[folder][name]).length">
            <h3 slot="top">{{name}}</h3>
            <sidebar-property-field
              v-for="(propKey, index) in Object.keys(contentComponentProps[folder][name])"
              :global="{ folder, name }"
              :prop="{
                name: propKey,
                type: contentComponentProps[folder][name][propKey].type,
                value: getGlobalComponentPropValue(folder, name, propKey),
              }"
              :key="'global-component-props-' + folder + name + index">
            </sidebar-property-field>
          </sidebar-section>
        </div>
      </sidebar-section>
      <!-- abandoning feature, unsure if even doable >
      <sidebar-section>
        <h3 slot="top">Custom Components</h3>
        <sidebar-property-field
          :prop="{
            name: 'selectedComponentTemplate',
            type: 'dropdown',
            options: getContentComponents(),
            value: selectedComponentTemplate,
          }">
        </sidebar-property-field>
        <input class="vlue-dev-sidebar-button"
          :disabled="!selectedComponentTemplate"
          type="button" value="Download Template" v-on:click="downloadVueComponent()">
        <input id="upload-vue-file-input"
          type="file"
          v-on:change="uploadVueComponent"
          accept=".vue">
        <input class="vlue-dev-sidebar-button"
          type="button" value="Upload Custom Component" v-on:click="uploadVueComponentClick()">
      </sidebar-section>
      <-->
      <sidebar-section class="vlue-dev-sidebar-selected-division"
        v-if="selectedContainer"
        :expandedByDefault="!selectedContainer.contentComponents">
        <h3 slot="top">Selected Division</h3>
        <sidebar-property-field
          v-for="(prop, index) in containerProps"
          v-if="prop.name != 'gridCellSize' || selectedContainer.align == 'grid'"
          :current="selectedContainer"
          :prop="{
            name: prop.name,
            type: prop.type,
            options: prop.options,
            value: selectedContainer[prop.name],
          }"
          :key="'selected-division-' + index">
        </sidebar-property-field>
      </sidebar-section>
      <sidebar-section class="vlue-dev-sidebar-selected-division-content-component"
        v-if="selectedContainer && selectedContainer.contentComponents"
        expandedByDefault>
        <h3 slot="top">Selected Component</h3>
        <input class="vlue-dev-sidebar-button"
          type="button"
          v-on:click="removeContentComponent(0)"
          value="Remove">
        <sidebar-property-field
          v-for="(propKey, index) in
          Object.keys(getContentComponentProp(selectedContainer.contentComponents[0]))"
          :current="selectedContainer.contentComponents[0].props"
          :prop="{
            name: propKey,
            type: getContentComponentProp(selectedContainer.contentComponents[0])[propKey].type,
            value: selectedContainer.contentComponents[0].props[propKey],
          }"
          :key="'selected-components-' + index">
        </sidebar-property-field>
      </sidebar-section>
    </section>
  </section>
</template>

<script lang="ts">
import Vue from 'vue'
import sidebarSection from './SidebarSection.vue'
import sidebarPropertyField from './SidebarPropertyField.vue'
import store from '../../store/store'
import { mapState, mapGetters } from 'vuex'
import $ from 'jquery'

export default Vue.extend({
  computed: {
    ...mapState([
      'mode',
      'website',
      'websiteHistoryUndo',
      'websiteHistoryRedo',
      'websiteGenerationSpinner',
      'selectedContainer',
      'selectedLayer',
      'editFrame',
      'editPage',
      'layerVisibility',
      'containerProps',
      'contentComponentProps',
      'selectedComponentTemplate',
      'currentPage',
      'viewportWidth',
    ]),
    ...mapGetters([
      'pageNames',
      'parentPageNames',
      'currentPageContainer',
      'currentPageContainerIndex',
    ]),
  },
  components: {
    sidebarSection,
    sidebarPropertyField,
  },
  methods: {
    undo() {
      store.dispatch("undo");
    },
    redo() {
      store.dispatch("redo");
    },
    setMode(value) {
      store.commit("setMode", value);
    },
    setSelectedLayer(value) {
      store.commit("setSelectedLayer", value);
    },
    setLayerVisibility(value) {
      store.commit("setLayerVisibility", value);
    },
    toggleEditFrame() {
      store.commit('toggleEditFrame');
    },
    toggleEditPage() {
      store.commit('toggleEditPage');
    },
    resetViewportWidth() {
      store.commit("resetViewportWidth");
    },
    setMobileMenuAlignment(value) {
      store.dispatch('changeWebsiteState', {
        mutation: 'setMobileMenuAlignment',
        params: { value },
      });
    },
    setMobileMenuType(value) {
      store.dispatch('changeWebsiteState', {
        mutation: 'setMobileMenuType',
        params: { value },
      });
    },
    swapMobileMenuColors() {
      store.dispatch('changeWebsiteState', {
        mutation: 'swapMobileMenuColors',
      });
    },
    addPage() {
      store.dispatch('changeWebsiteState', {
        mutation: 'addPage',
      });
    },
    removePage() {
      store.dispatch('changeWebsiteState', {
        mutation: 'removePage',
      });
    },
    sortPage(direction) {
      store.dispatch('changeWebsiteState', {
        mutation: 'sortPage',
        params: { direction },
      });
    },
    getGlobalComponentPropValue(folder, name, propKey) {
      return this.website.globalComponentPropValues[folder]?.[name]?.[propKey];
    },
    sortContentComponent(direction, index) {
      store.dispatch('changeWebsiteState', {
        mutation: 'sortContentComponent',
        params: { direction, index },
      });
    },
    removeContentComponent(index) {
      store.dispatch('changeWebsiteState', {
        mutation: 'removeContentComponent',
        params: { index },
      });
    },
    async downloadVueComponent() {
      let vueComponentContent = await $.get(
        `components/${this.selectedComponentTemplate}.vue`.split(' ').join(''),
        () => {},
        'text'
      );
      const dataString = "data:text/json;charset=utf-8," + encodeURIComponent(vueComponentContent);
      const element = document.createElement('a');
      element.setAttribute("href", dataString);
      element.setAttribute("download", this.selectedComponentTemplate.split(' / ')[1] + '.vue');
      document.body.appendChild(element); // required for firefox
      element.click();
      element.remove();
    },
    uploadVueComponent(event) {
      store.commit("uploadVueComponent", {
        file: event.target.files[0],
      });
      // reset value so that change event is triggered even when selecting the same file again
      event.target.value = null;
    },
    uploadVueComponentClick() {
      document.getElementById('upload-vue-file-input')?.click();
    },
    getContentComponents() {
      // convert from object containing objects to array of strings
      return Object.keys(this.contentComponentProps).reduce((acc, folder) => [
        ...acc,
        ...Object.keys(this.contentComponentProps[folder]).map(name => folder + ' / ' + name),
      ], [] as string[]);
    },
    getContentComponentProp(content) {
      return this.contentComponentProps[content.pathway.folder][content.pathway.name];
    },
    downloadGeneratedWebsite() {
      store.commit("downloadGeneratedWebsite");
    },
    uploadGeneratedWebsite(event) {
      store.commit("uploadGeneratedWebsite", {
        file: event.target.files[0],
      });
      // reset value so that change event is triggered even when selecting the same file again
      event.target.value = null;
    },
    uploadGeneratedWebsiteClick() {
      document.getElementById('upload-zip-file-input')?.click();
    },
    saveChanges() {
      store.commit("saveChanges");
    },
    revertChanges() {
      store.dispatch('changeWebsiteState', { mutation: 'getWebsiteJson' });
    },
    cleanSlate() {
      store.dispatch('changeWebsiteState', { mutation: 'cleanSlate' });
    },
    isDevelopment() {
      return process.env.NODE_ENV !== 'production'
    },
  }
})
</script>

<style lang="scss">
  @import "../../style/vars.scss";

  #vlue-dev-sidebar {
    position: fixed;
    top: 0;
    right: - $standard-scrollbar-width;
    height: 100vh;
    display: flex;
    flex-direction: column;
    overflow: hidden;
    width: $standard-scrollbar-width;
    background: $vlue-dev-bg-color;
    > section {
      overflow-y: scroll;
      width: $vlue-dev-sidebar-width;
    }
    hr {
      border: none;
      border-top: 1px solid #0002;
      margin-bottom: 10px;
    }
    input[type="file"] {
      display: none;
    }
  }
  #vlue-dev-sidebar,
  #vlue-dev-image-select,
  #vlue-dev-font-select {
    h3 {
      color: white;
      font-size: 14px;
      font-weight: normal;
      text-align: left;
      margin: 0 10px 10px;
      padding: 0;
    }
  }
  .dev #vlue-dev-sidebar {
    width: 219px;
  }
  #vlue-dev-sidebar-top {
    flex-shrink: 0;
    box-shadow: 0 10px 10px rgba(0,0,0,0.1);
  }
  #vlue-dev-sidebar-main {
    flex: auto;
    padding: 10px 0 50px 0;
  }
  #vlue-dev-sidebar-logo {
    background-image: url("../../../public/core/images/logo.png");
    background-size: cover;
    background-position-y: -25%;
    width: 100%;
    height: 60px;
    transition: $vlue-transition-duration;
    &:hover {
      background-position-y: 1%;
      height: 210px;
    }
  }
  .vlue-dev-sidebar-text-area,
  .vlue-dev-sidebar-text-field,
  .vlue-dev-sidebar-dropdown,
  .vlue-dev-sidebar-color,
  .vlue-dev-sidebar-button {
    width: calc(100% - 20px);
    box-sizing: border-box;
    border: none;
    text-align: left;
    margin: 0 10px 10px;
    padding: 10px 20px;
    border-radius: 5px;
    background: rgba(0,0,0,0.2);
    color: white;
    resize: none;
    overflow: hidden;
    transition: $vlue-transition-duration;
    &:disabled {
      color: rgba(255,255,255,0.25);
    }
    &.selected {
      transition: 0s;
      box-shadow: inset 0 10px 10px rgba(0,0,0,0.3);
    }
  }
  .vlue-dev-sidebar-button-spinner {
    width: 10px;
    height: 10px;
    border: 5px
    solid $vlue-sidebar-highlight;
    border-color:
      $vlue-sidebar-highlight
      $vlue-sidebar-highlight
      transparent
      transparent;
    border-radius: 50%;
    animation: sidebar-spinning 0.25s linear infinite;
    margin: -5px 0 -5px 20px;
    position: relative;
    left: 140px;
    top: -32px;
    margin-bottom: -15px;
  }
  .vlue-dev-sidebar-button:enabled:not(.selected) {
    &:hover {
      background-color: rgba(0,0,0,0.1);
      padding-left: 30px;
    }
    &:active {
      transition: 0s;
      background-color: rgba(0,0,0,0.3);
      padding-left: 20px;
      box-shadow: inset 0 10px 10px rgba(0,0,0,0.2);
    }
  }
  .vlue-dev-sidebar-button-row {
    display: flex;
    margin: 0 0 10px 10px;
    &.vlue-dev-sidebar-button-row-layers {
      .vlue-dev-sidebar-button:nth-child(2) {
        flex-basis: 30%;
        padding: 10px;
        &:hover {
          padding: 10px;
        }
      }
    }
    input[type="button"].vlue-dev-sidebar-button {
      margin: 0 10px 0 0;
      text-align: center;
      font-weight: bolder;
      &:hover {
        padding-left: 20px;
      }
      &#vlue-dev-sidebar-button-create,
      &#vlue-dev-sidebar-button-edit,
      &#vlue-dev-sidebar-button-move,
      &#vlue-dev-sidebar-button-delete {
        padding: 10px;
        &:hover,
        &:active {
          padding: 10px;
        }
      }
    }
  }
  .vlue-dev-sidebar-selected-division-content-component {
    position: relative;
    font-size: 0;
    .vlue-dev-sidebar-button.vlue-dev-sidebar-button-small {
      width: 20px;
      height: 20px;
      font-family: monospace;
      text-align: center;
      position: absolute;
      right: 40px;
      margin: -1.5px 0 0 0;
      padding: 0 0 2px 0;
      border-radius: 50%;
      transform: rotate(90deg);
      font-size: 14px;
      font-weight: bolder;
      line-height: 0px;
      &:hover,
      &:active {
        padding: 0 0 2px 0;
      }
      &:nth-child(3) {
        right: 70px;
      }
    }
  }
  .create #vlue-dev-sidebar-button-create,
  .edit #vlue-dev-sidebar-button-edit,
  .move #vlue-dev-sidebar-button-move,
  .delete #vlue-dev-sidebar-button-delete {
    transition: 0s;
    box-shadow: inset 0 10px 10px rgba(0,0,0,0.3);
    &#vlue-dev-sidebar-button-create {
      background: $vlue-color-create;
    }
    &#vlue-dev-sidebar-button-edit {
      background: $vlue-color-edit;
    }
    &#vlue-dev-sidebar-button-move {
      background: $vlue-color-move;
    }
    &#vlue-dev-sidebar-button-delete {
      background: $vlue-color-delete;
    }
  }

  @keyframes sidebar-spinning {
    from {
      transform: rotate(0deg);
    }
    to {
      transform: rotate(360deg);
    }
  }
</style>
